#ifndef CLIPPINGFILE_H
#define CLIPPINGFILE_H

#ifndef FLYPAPERAPP_H
#include "FlyPaperApp.h"
#endif

#ifndef __DRAG__
#include <Drag.h>
#endif

typedef struct {
	Point					dropSpot;
} FlyPaperAuxDataRec, **FlyPaperAuxDataHandle;

// #define		kClippingFileSignature		'drag'
// #define		kClippingFileType			'clpu'

#define		kClippingFileSignature		'FlyP'
#define		kClippingFileType			'FlyD'

#define		kDragResourceResType		'drag'
#define		kDragResourceResID			128
#define		kFlavorResID				256
#define		kAuxDataResType				kSignature
#define		kAuxDataResID				128

typedef struct {
	FlavorType				flavorType;		//				the type
	unsigned long			reserved1;		// 0x00000100	???
	unsigned long			reserved2;		// 0x00000000	???
	unsigned long			reserved3;		// 0x00000000	???
	
} DragResourceFlavorRec;

typedef struct {
	unsigned long			version;		// 0x00000001	I think this is a version#
	unsigned long			reserved1;		// 0x00000000	//	???
	unsigned long			reserved2;		// 0x00000000	//	???
	unsigned short			reserved3;		// 0x0000		//	could be high word of flavorCount
	unsigned short			flavorCount;	//				//	# of flavors, could be long
	DragResourceFlavorRec	flavors [];
	
} DragResourceHeaderRec, **DragResourceHeader;

typedef unsigned long ClippingID;

OSErr	CreateClippingFile (short *fRefNum, OSType fileType, FlyPaperAuxDataHandle& auxData,
		ClippingID& clippingID);
OSErr	AddFlavorToClippingFile (short clippingRefNum, FlavorType flavorType, Handle flavorData);
OSErr	ClippingFileToDragReference (ClippingID id, DragReference& dragRef, Boolean loadit);
OSErr	DeleteClippingFile (ClippingID id);
OSErr	GetClippingFileAuxData (ClippingID id, FlyPaperAuxDataHandle& data);
Boolean InitClippingFile (void);
OSErr	ExtractFlavorFromClippingFile (ClippingID id, FlavorType whichFlavor, Handle &outHandle);
OSErr	OpenClippingFile (ClippingID id, short& fileRef);

#endif
